Subject: bug#78844: 30.1; feature request: public interface for querying builtin packages and versions

From: Sean Whitton <[email-masked]>
Date: Wed, 25 Jun 2025 10:41:22 +0100

Hello,

On Tue 24 Jun 2025 at 04:26pm -04, Stefan Monnier via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:

>> This is mainly used for external tooling.  Having a list of
>> bundled/builtin packages and versions can help distribution package
>> manager, e.g. APT in Debian, to manage dependencies easier (as mentioned
>> in my first email).  We need to generate the package information and
>> store it in the Debian package info for those tools to use as they
>> cannot query Emacs in runtime.
>
> Ah, I see, so you really want to export the whole of
> `package--builtin-versions` rather than just the list of builtin
> packages.  This way you can later test for specific packages and/or
> versions without running Emacs (modulo compatibility between Emacs's
> notion of ordering between versions and that of what your external tool
> uses).

We want the Emacs binary package to have "Provides: elpa-org (>= 9.7)"
on it.  That way it can satisfy a dependency on elpa-org just like the
actual elpa-org package can.  And so on for all the others.

-- 
Sean Whitton